/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gottamm.util;

import gottamm.entities.Folder;
import gottamm.sessionbeans.FolderFacadeLocal;
import java.io.File;
import java.lang.reflect.InvocationTargetException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 *
 * @author Thomas
 */
public class FileUtile {

    private static FolderFacadeLocal folderFacade = lookupFolderFacadeLocal();

    /**
     *  Function to apply a function to pass a parameter on the file with a path recursively
     * 
     * @param String Path folder recursively
     * @param Method A method have signature public static Object meth(File f)
     * @return ArrayList<Object> The ArrayList to the Object return by a method
     * @throws IllegalAccessException, IllegalArgumentException, InvocationTargetException
     */
    public static ArrayList recursivelyAppliedFileForMP3(String dir) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException {
        ArrayList allFiles = new ArrayList();
        getFilesRec(allFiles, dir, null);
        return allFiles;
    }

    private static Folder getFilesRec(ArrayList allFiles, String root, Folder parent) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException {
        Object m;
        File f = new File(root);
        Folder fo = folderFacade.findByPath(root);
        List<Object> LMC = new ArrayList();
        Folder folder;
        if (fo == null) {
            folder = new Folder(f.getName(), f.getAbsolutePath(), parent);
            folderFacade.create(folder);
            folder.maj();
            File[] listFiles = f.listFiles();
            Folder rtnTmp;
            List<Folder> LAB = new ArrayList();
            for (int i = 0; i < listFiles.length; i++) {
                if (listFiles[i].isDirectory()) {
                    rtnTmp = getFilesRec(allFiles, listFiles[i].toString(), folder);
                    if (rtnTmp != null) {
                        LAB.add(rtnTmp);
                    }
                } else {
                    m = ID3Util.lectureFile(listFiles[i], folder);
                    if (m != null) {
                        LMC.add(m);
                    }
                }
            }
            if (LAB.isEmpty() && LMC.isEmpty()) {
                //System.out.println("Remove: " + folder.getFolderPath());
                /*
                if (folder.getFolders().isEmpty()) System.out.println("Pas de Fils");
                if (folder.getMusics().isEmpty()) System.out.println("Pas de Music");
                for (Folder fTmp : folder.getFolders()) {
                    System.out.println("Fils: " + fTmp.getFolderPath());
                }
                */
                if (folder.getParent() != null) {
                    //System.out.println("Parent is : " + folder.getParent().getFolderPath());
                    folder.getParent().getFolders().remove(folder);
                    folder.setParent(null);
                } else {
                    //System.out.println("No Parent");
                }
                folderFacade.remove(folder);
                return null;
            } else {
                allFiles.addAll(LMC);
                return folder;
            }
        } else {
            folder = fo;
            folder.setParent(parent);
            folder.maj();
            return folder;
        }
    }

    private static FolderFacadeLocal lookupFolderFacadeLocal() {
        try {
            Context c = new InitialContext();
            return (FolderFacadeLocal) c.lookup("java:global/Gottamm/Gottamm-ejb/FolderFacade!gottamm.sessionbeans.FolderFacadeLocal");
        } catch (NamingException ne) {
            //Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }
}
