/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gottamm.util;

import gottamm.entities.*;
import gottamm.sessionbeans.*;
import java.io.*;
import java.util.ArrayList;
import java.util.List;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import org.farng.mp3.*;
import org.farng.mp3.id3.*;

/**
 *
 * @author Strangi Thomas
 */
public class ID3Util {

    private static ArrayList<String> genreString = new ArrayList<String>();
    private static AlbumFacadeLocal albumFacade = lookupAlbumFacadeLocal();
    private static ArtistFacadeLocal artistFacade = lookupArtistFacadeLocal();
    private static MusicFacadeLocal musicFacade = lookupMusicFacadeLocal();

    /**
     * Static methode for creating music proceeding from a File
     * @param f File file MP3
     * @return Music
     *
     */
    public static Music lectureFile(File f, Folder parent) {
        Music m;
        Long lastMod = f.lastModified();
        String nameFile = f.getName();
        String absolutePath = f.getAbsolutePath();
        //System.out.println("onestlaavec : "+f.getAbsolutePath());
        try {
            if (nameFile.substring(nameFile.length() - 4, nameFile.length()).equals(".mp3")) {
                MP3File mp3file;
                try {
                    mp3file = new MP3File(f);
                } catch (TagException e) {
                    mp3file = null;
                }
                if (mp3file != null) {
                    if (mp3file.hasID3v1Tag()) {
                        if (mp3file.hasID3v2Tag()) {
                        }
                        ID3v1 id3 = mp3file.getID3v1Tag();
                        if (id3 != null) {
                            String title = id3.getTitle();
                            String artistS = id3.getArtist();
                            String albumS = id3.getAlbum();
                            String trackNumString = "0";
                            try {
                                trackNumString = id3.getTrackNumberOnAlbum();
                            } catch (UnsupportedOperationException e) {
                            }
                            Integer track = Integer.valueOf(trackNumString);
                            Integer year = 0;
                            if (!id3.getYearReleased().equals("")) {
                                year = Integer.valueOf(id3.getYearReleased());
                            }
                            String genre = id3.getSongGenre();
                            Artist a;
                            Artist artist;
                            if (artistS.equals("")) {
                                artistS = "Inconnu";
                                a = artistFacade.findByName(artistS);
                                if (a == null) {
                                    artist = new Artist(artistS);
                                    artistFacade.create(artist);
                                } else {
                                    artist = a;
                                }
                            } else {
                                a = artistFacade.findByName(artistS);
                                if (a == null) {
                                    artist = new Artist(artistS);
                                    artistFacade.create(artist);
                                } else {
                                    artist = a;
                                }
                            }
                            Album al;
                            Album album;
                            if (albumS.equals("")) {
                                albumS = "Inconnu";
                                al = albumFacade.findByName(albumS);
                                if (al == null) {
                                    album = new Album(albumS, artist);
                                    albumFacade.create(album);
                                    album.maj();
                                } else {
                                    album = al;
                                    if (!album.getArtist().contains(artist)) {
                                        artist.addAlbum(album);
                                        album.addArtist(artist);
                                    }
                                }
                            } else {
                                al = albumFacade.findByName(albumS);
                                if (al == null) {
                                    album = new Album(albumS, artist);
                                    albumFacade.create(album);
                                    album.maj();
                                } else {
                                    album = al;
                                    if (!album.getArtist().equals(artist)) {
                                        if (!artist.getAlbums().contains(album)) {
                                            List<Album> albums = artist.getAlbums();
                                            albums.add(album);
                                            artist.setAlbums(albums);
                                        }
                                    }
                                }
                            }
                            Music mu = musicFacade.findByPath(absolutePath);
                            if (mu == null) {
                                m = new Music(title, artist, album, track, year, genre, absolutePath, lastMod, parent);
                                musicFacade.create(m);
                                m.maj();
                            } else {
                                m = mu;
                                Music m2 = new Music(title, artist, album, track, year, genre, absolutePath, lastMod, parent);
                                if (m.equalsTAG(m2)) {
                                    //m = null;
                                } else {
                                    m.setAlbum(m2.getAlbum());
                                    m.setArtist(m2.getArtist());
                                    m.setDuration(m2.getDuration());
                                    m.setGenre(m2.getGenre());
                                    m.setMusic_year(m2.getMusic_year());
                                    m.setTitle(m2.getTitle());
                                    m.setTrack(m2.getTrack());
                                }
                            }
                        } else {
                            m = null;
                        }
                    } else {
                        m = null;
                    }
                } else {
                    m = null;
                }
            } else {
                m = null;
            }
        } catch (Exception e) {
            m = null;
        }
        return m;
    }

    public static void tableauDeBytesVersFichier(byte[] tableau, java.io.File fichier)
            throws java.io.IOException {
        java.io.FileWriter f = new java.io.FileWriter(fichier);
        for (int i = 0; i < tableau.length; i++) {
            f.write(tableau[i]);
        }
        f.close();
    }

    private static MusicFacadeLocal lookupMusicFacadeLocal() {
        try {
            Context c = new InitialContext();
            return (MusicFacadeLocal) c.lookup("java:global/Gottamm/Gottamm-ejb/MusicFacade!gottamm.sessionbeans.MusicFacadeLocal");
        } catch (NamingException ne) {
            //Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    private static ArtistFacadeLocal lookupArtistFacadeLocal() {
        try {
            Context c = new InitialContext();
            return (ArtistFacadeLocal) c.lookup("java:global/Gottamm/Gottamm-ejb/ArtistFacade!gottamm.sessionbeans.ArtistFacadeLocal");
        } catch (NamingException ne) {
            //Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    private static AlbumFacadeLocal lookupAlbumFacadeLocal() {
        try {
            Context c = new InitialContext();
            return (AlbumFacadeLocal) c.lookup("java:global/Gottamm/Gottamm-ejb/AlbumFacade!gottamm.sessionbeans.AlbumFacadeLocal");
        } catch (NamingException ne) {
            //Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }

    public static String getGenreString(int num) {
        if (genreString.isEmpty()) {
            genreString.add(0, "Blues");
            genreString.add(1, "Classic rock");
            genreString.add(2, "Country");
            genreString.add(3, "Dance");
            genreString.add(4, "Disco");
            genreString.add(5, "Funk");
            genreString.add(6, "Grunge");
            genreString.add(7, "Hip-Hop");
            genreString.add(8, "Jazz");
            genreString.add(9, "Metal");
            genreString.add(10, "New Age");
            genreString.add(11, "Oldies");
            genreString.add(12, "Autre");
            genreString.add(13, "Pop");
            genreString.add(14, "R'n'B");
            genreString.add(15, "Rap");
            genreString.add(16, "Raggae");
            genreString.add(17, "Rock");
            genreString.add(18, "Techno");
            genreString.add(19, "Musique industrielle");
            genreString.add(20, "Rock Alternatif (Alternative)");
            genreString.add(21, "Ska");
            genreString.add(22, "Death Metal");
            genreString.add(23, "Pranks");
            genreString.add(24, "Musique de Film");
            genreString.add(25, "Euro-Techno");
            genreString.add(26, "Ambient");
            genreString.add(27, "Trip-hop");
            genreString.add(28, "Musique Vocale");
            genreString.add(29, "Jazz-Funk");
            genreString.add(30, "Fusion");
            genreString.add(31, "Trance");
            genreString.add(32, "Musique Classique");
            genreString.add(33, "Instrumental");
            genreString.add(34, "Acid");
            genreString.add(35, "House");
            genreString.add(36, "Musique de Jeux-vidéo");
            genreString.add(37, "Extrait Sonore");
            genreString.add(38, "Gospel");
            genreString.add(39, "Musique bruitiste");
            genreString.add(40, "Rock alternatif");
            genreString.add(41, "Bass");
            genreString.add(42, "Soul");
            genreString.add(43, "Punk");
            genreString.add(44, "Space");
            genreString.add(45, "Musique de médiation (Meditative)");
            genreString.add(46, "Pop instrumental");
            genreString.add(47, "Rock instrumental");
            genreString.add(48, "Musique ethnique");
            genreString.add(49, "Gothique");
            genreString.add(50, "Darkwave");
            genreString.add(51, "Techno-Industrial");
            genreString.add(52, "Musique électronique");
            genreString.add(53, "Pop-Folk");
            genreString.add(54, "Eurodance");
            genreString.add(55, "Dream");
            genreString.add(56, "Rock sudiste (Southern Rock)");
            genreString.add(57, "Comédie");
            genreString.add(58, "Morceau \"culte\" (Cult)");
            genreString.add(59, "Gangsta");
            genreString.add(60, "Hit-parade");
            genreString.add(61, "Rap chrétien (Christian Rap)");
            genreString.add(62, "Pop/Funk");
            genreString.add(63, "Jungle");
            genreString.add(64, "Musique amérindienne");
            genreString.add(65, "Cabaret");
            genreString.add(66, "New wave");
            genreString.add(67, "Psychédélique");
            genreString.add(68, "Rave");
            genreString.add(69, "Comédie musicale (Showtunes)");
            genreString.add(70, "Bande-annonce");
            genreString.add(71, "Lo-fi");
            genreString.add(72, "Musique tribale");
            genreString.add(73, "Acid Punk");
            genreString.add(74, "Acid Jazz");
            genreString.add(75, "Polka");
            genreString.add(76, "Rétro");
            genreString.add(77, "Théâtre");
            genreString.add(78, "Rock & Roll");
            genreString.add(79, "Hard Rock");
            genreString.add(80, "Folk");
            genreString.add(81, "Folk rock");
            genreString.add(82, "Folk américain");
            genreString.add(83, "Swing");
            genreString.add(84, "Fast Fusion");
            genreString.add(85, "Bebop");
            genreString.add(86, "Musique latine");
            genreString.add(87, "Revival");
            genreString.add(88, "Musique celtique");
            genreString.add(89, "Bluegrass");
            genreString.add(90, "Avantgarde");
            genreString.add(91, "Gothic Rock");
            genreString.add(92, "Rock progressif");
            genreString.add(93, "Rock psychédélique");
            genreString.add(94, "Rock symphonique");
            genreString.add(95, "Slow Rock");
            genreString.add(96, "Big Band");
            genreString.add(97, "Chœur");
            genreString.add(98, "Easy listening");
            genreString.add(99, "Acoustic (Acoustique)");
            genreString.add(100, "Humour");
            genreString.add(101, "Discours (Speech)");
            genreString.add(102, "Chanson");
            genreString.add(103, "Opéra");
            genreString.add(104, "Musique de chambre");
            genreString.add(105, "Sonate");
            genreString.add(106, "Symphonie");
            genreString.add(107, "Booty Bass");
            genreString.add(108, "Primus");
            genreString.add(109, "Porn groove");
            genreString.add(110, "Satire");
            genreString.add(111, "R'n'B contemporain");
            genreString.add(112, "Club");
            genreString.add(113, "Tango");
            genreString.add(114, "Samba");
            genreString.add(115, "Folklore");
            genreString.add(116, "Ballade");
            genreString.add(117, "Power ballad");
            genreString.add(118, "Rythmic soul");
            genreString.add(119, "Freestyle");
            genreString.add(120, "Duo");
            genreString.add(121, "Punk rock");
            genreString.add(122, "Drum Solo (solo de batterie)");
            genreString.add(123, "A cappella");
            genreString.add(124, "Euro-house");
            genreString.add(125, "Dancehall");
            genreString.add(126, "Goa");
            genreString.add(127, "Drum and bass");
            genreString.add(128, "Club House");
            genreString.add(129, "Hardcore");
            genreString.add(130, "Terror");
            genreString.add(131, "Indie");
            genreString.add(132, "BritPop");
            genreString.add(133, "BritPop");
            genreString.add(134, "Polsk Punk");
            genreString.add(135, "Beat");
            genreString.add(136, "Gangsta rap chrétien");
            genreString.add(137, "Heavy metal");
            genreString.add(138, "Black metal");
            genreString.add(139, "Crossover");
            genreString.add(140, "Musique chrétienne contemporaine");
            genreString.add(141, "Rock chrétien");
            genreString.add(142, "Merengue");
            genreString.add(143, "Salsa");
            genreString.add(144, "Thrash metal");
            genreString.add(145, "Anime");
            genreString.add(146, "JPop");
            genreString.add(147, "Synthpop");
        }
        if (0 <= num && num < 148) {
            return genreString.get(num);
        } else {
            return "Genre non connu";
        }
    }
}
